//
//  RollViewController.m
//  label
//
//  Created by 梁羽 on 2017/4/6.
//  Copyright © 2017年 梁羽. All rights reserved.
//

#import "RollViewController.h"

@interface RollViewController ()
{
    UIView *_backView;
    NSTimer *_timer;
    NSInteger _seconds;
    UILabel *_descLabel;
}
@property (nonatomic, strong) NSTimer *timer;
@property (nonatomic, strong) NSMutableArray *labelArr;
@end

@implementation RollViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    self.view.backgroundColor = [UIColor whiteColor];
    _seconds = 0;
    _labelArr = [NSMutableArray new];
    _backView = [[UIView alloc] initWithFrame:CGRectMake(100, 100, 200, 20)];
    _backView.backgroundColor = [UIColor redColor];
    _backView.clipsToBounds = YES;
    _backView.userInteractionEnabled = YES;
    [self.view addSubview:_backView];
    
    __weak typeof(self) weakSelf = self;
    _timer = [NSTimer scheduledTimerWithTimeInterval:2.6 target:weakSelf selector:@selector(timerRepeat) userInfo:nil repeats:YES];
    _timer.fireDate = [NSDate distantFuture];
    
    [self creatCicleLabel];
}

-(void)creatCicleLabel {
    for (int i = 0; i < 2; i ++) {
        UILabel *scrollLabel = [[UILabel alloc] initWithFrame:CGRectMake(10, 20, 180, 20)];
        scrollLabel.backgroundColor = [UIColor clearColor];
        scrollLabel.textAlignment = NSTextAlignmentCenter;
        [_backView addSubview:scrollLabel];
        scrollLabel.tag = 3000 + i;
        scrollLabel.userInteractionEnabled = YES;
        [_labelArr addObject:scrollLabel];
        
        UITapGestureRecognizer *tap = [[UITapGestureRecognizer alloc] initWithTarget:self action:@selector(labelClick:)];
        [scrollLabel addGestureRecognizer:tap];
        
        UIButton *clickBtn = [UIButton buttonWithType:UIButtonTypeCustom];
        clickBtn.frame = CGRectMake(30+(100+30)*i, 200, 100, 40);
        [clickBtn setTitle:@[@"点我开始",@"点我关闭"][i] forState:UIControlStateNormal];
        [clickBtn setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
        clickBtn.tag = 1000 + i;
        [clickBtn addTarget:self action:@selector(buttonClick:) forControlEvents:UIControlEventTouchUpInside];
        [self.view addSubview:clickBtn];
    }
    
    UILabel *descLabel = [[UILabel alloc] initWithFrame:CGRectMake(30, 300, 100, 40)];
    descLabel.textAlignment = NSTextAlignmentCenter;
    [self.view addSubview:descLabel];
    _descLabel = descLabel;
    
    UIButton *closeBtn = [UIButton buttonWithType:UIButtonTypeCustom];
    closeBtn.frame = CGRectMake(0, 20, 50, 50);
    [closeBtn setTitle:@"关闭" forState:UIControlStateNormal];
    [closeBtn setTitleColor:[UIColor redColor] forState:UIControlStateNormal];
    [closeBtn addTarget:self action:@selector(closeClick) forControlEvents:UIControlEventTouchUpInside];
    [self.view addSubview:closeBtn];
}

-(void)timerRepeat {
    UILabel *targetLab = [_labelArr objectAtIndex:_seconds % 2];
    targetLab.text = [NSString stringWithFormat:@"%ld",_seconds];
    targetLab.backgroundColor = [UIColor whiteColor];
    [_backView bringSubviewToFront:targetLab];
    [UIView animateWithDuration:0.3 animations:^{
        targetLab.frame = CGRectMake(10, 0, 180, 20);
    } completion:^(BOOL finished) {
        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
            [UIView animateWithDuration:0.3 animations:^{
                targetLab.frame = CGRectMake(10, -20, 180, 20);
            } completion:^(BOOL finished) {
                targetLab.frame = CGRectMake(10, 20, 180, 20);
            }];
        });
    }];
    _seconds++;
}

-(void)buttonClick:(UIButton *)button {
    if (button.tag - 1000 == 0) {
        _timer.fireDate = [NSDate distantPast];
    }
    if (button.tag - 1000 == 1) {
        _timer.fireDate = [NSDate distantFuture];
    }
}

-(void)labelClick:(UITapGestureRecognizer *)tap {
    UILabel *targetLabel = (UILabel *)tap.view;
    _descLabel.text = [NSString stringWithFormat:@"%ld--%@",tap.view.tag,targetLabel.text];
}

-(void)closeClick {
    if (_timer) {
        [_timer invalidate];
        _timer = nil;
    }
    [self dismissViewControllerAnimated:YES completion:nil];
}

-(void)dealloc {
    NSLog(@"dealloc");
}

@end
